stages:
  - build
  - test
  - publish
  - deploy

image: maven:3.6.3-jdk-11

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  POSTGRES_URL: "jdbc:postgresql://postgres:5432/crimespot"
  POSTGRES_DB: crimespot
  POSTGRES_USER: crimespot
  POSTGRES_PASSWORD: crimespot
  POSTGRES_HOST_AUTH_METHOD: trust

before_script:
  - IP=$(hostname -I | awk '{print $1}')

build-app:
  cache:
    paths:
      - .m2/repository/
      - target/
    policy: push
  stage: build
  script:
    - mvn clean install -DskipTests -B
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: on_success
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: on_success

#.test-web:
#  variables:
#    BROWSER_NAME: ""
#    GRID_URL: ""
#  artifacts:
#    paths:
#      - test_html_dumps/
#      - test_screenshots/
#    expire_in: 1 week
#    when: on_failure
#  cache:
#    paths:
#      - .m2/repository/
#      - target/
#    policy: pull
#  stage: test
#  script:
#    - hostname
#    - mvn -Dtest='felipe.emerim.crimespot.web.test.**'
#      -DbrowserName=$BROWSER_NAME -DuseHub=true -DgridUrl=$GRID_URL -DisHeadless=true
#      -DpageUrl=http://$IP -Dspring.profiles.active=testing-ci
#      clean test
#  rules:
#    - if: '$CI_COMMIT_BRANCH == "master" && $CI_COMMIT_TAG == "ui-tests"'
#      when: on_success
#
#test-chrome:
#  extends: .test-web
#  variables:
#    BROWSER_NAME: "chrome"
#    GRID_URL: "http://selenium-standalone-chrome:4444/wd/hub"
#  services:
#    - postgres:13-alpine
#    - selenium/standalone-chrome
#
#test-firefox:
#  extends: .test-web
#  variables:
#    BROWSER_NAME: "firefox"
#    GRID_URL: "http://selenium-standalone-firefox:4444/wd/hub"
#  services:
#    - postgres:13-alpine
#    - selenium/standalone-firefox

test-unit:
  cache:
    paths:
      - .m2/repository/
      - target/
    policy: pull
  stage: test
  services:
    - postgres:13-alpine
  script:
    - mvn -Dtest='!felipe.emerim.crimespot.web.test.**' -Dspring.profiles.active=testing-ci
      clean test
    - cat target/site/jacoco/index.html
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: on_success
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: on_success

publish-jar:
  cache:
    paths:
      - .m2/repository/
      - target/
    policy: pull
  artifacts:
    paths:
      - release/crimespot.jar
    expire_in: 1 week
    when: on_success
  stage: publish
  script:
    - mvn clean package -DskipTests spring-boot:repackage
    - mkdir release
    - mv target/crimespot-0.0.1-SNAPSHOT.jar release/crimespot.jar
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: on_success

deploy-jar:
  image: ubuntu
  dependencies:
    - publish-jar
  stage: deploy
  before_script:
    ##
    ## Install ssh-agent if not already installed, it is required by Docker.
    ## (change apt-get to yum if you use an RPM-based image)
    ##
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )'

    ##
    ## Run ssh-agent (inside the build environment)
    ##
    - eval $(ssh-agent -s)

    ##
    ## Create the SSH directory and give it the right permissions
    ##
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh

    ##
    ## Assuming you created the SSH_KNOWN_HOSTS variable, uncomment the
    ## following two lines.
    ##
    - echo "$SSH_KNOWN_HOSTS" >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts

    ##
    ## Add the SSH key stored in SSH_PRIVATE_KEY variable to the agent store
    ## We're using tr to fix line endings which makes ed25519 keys work
    ## without extra base64 encoding.
    ## https://gitlab.com/gitlab-examples/ssh-private-key/issues/1#note_48526556
    ##
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/key
    - chmod 700 ~/.ssh/key

  script:
    - scp -o 'IdentitiesOnly=yes' -i ~/.ssh/key release/crimespot.jar $SSH_USER@$SSH_HOST:$APP_PATH
    - ssh -o 'IdentitiesOnly=yes' -i ~/.ssh/key $SSH_USER@$SSH_HOST 'sudo systemctl restart crimespot'
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: manual
      allow_failure: true

